## GtkExpander

GtkExpander

## Functions

GtkWidget * | gtk_expander_new ()
GtkWidget * | gtk_expander_new_with_mnemonic ()
void | gtk_expander_set_expanded ()
gboolean | gtk_expander_get_expanded ()
void | gtk_expander_set_spacing ()
gint | gtk_expander_get_spacing ()
void | gtk_expander_set_label ()
const gchar * | gtk_expander_get_label ()
void | gtk_expander_set_use_underline ()
gboolean | gtk_expander_get_use_underline ()
void | gtk_expander_set_use_markup ()
gboolean | gtk_expander_get_use_markup ()
void | gtk_expander_set_label_widget ()
GtkWidget * | gtk_expander_get_label_widget ()
void | gtk_expander_set_label_fill ()
gboolean | gtk_expander_get_label_fill ()

## Properties

gboolean | expanded | Read / Write / Construct
char * | label | Read / Write / Construct
gboolean | label-fill | Read / Write / Construct
GtkWidget * | label-widget | Read / Write
int | spacing | Read / Write
gboolean | use-markup | Read / Write / Construct
gboolean | use-underline | Read / Write / Construct

## Style Properties

int | expander-size | Read
int | expander-spacing | Read

## Signals

void | activate | Action

## Types and Values

struct | GtkExpander

## Object Hierarchy

        GObject
        ╰── GInitiallyUnowned
            ╰── GtkObject
                ╰── GtkWidget
                    ╰── GtkContainer
                        ╰── GtkBin
                            ╰── GtkExpander

## Implemented Interfaces

GtkExpander implements AtkImplementorIface and GtkBuildable.

## Includes

    #include <gtk/gtk.h>

## Description

## Functions

### gtk_expander_new ()

    GtkWidget *
    gtk_expander_new (const gchar *label);

Creates a new expander using `label` as the text of the label.

#### Parameters

label | the text of the label |

#### Returns

a new GtkExpander widget.

Since: 2.4

### gtk_expander_new_with_mnemonic ()

    GtkWidget *
    gtk_expander_new_with_mnemonic (const gchar *label);

Creates a new expander using `label` as the text of the label. If characters in `label` are preceded by an underscore, they are underlined. If you need a literal underscore character in a label, use '__' (two underscores). The first underlined character represents a keyboard accelerator called a mnemonic. Pressing Alt and that key activates the button.

#### Parameters

label | the text of the label with an underscore in front of the mnemonic character. | [allow-none]

#### Returns

a new GtkExpander widget.

Since: 2.4

### gtk_expander_set_expanded ()

    void
    gtk_expander_set_expanded (GtkExpander *expander,
                               gboolean expanded);

Sets the state of the expander. Set to `TRUE`, if you want the child widget to be revealed, and `FALSE` if you want the child widget to be hidden.

#### Parameters

expander | a GtkExpander |
expanded | whether the child widget is revealed |

Since: 2.4

### gtk_expander_get_expanded ()

    gboolean
    gtk_expander_get_expanded (GtkExpander *expander);

Queries a GtkExpander and returns its current state. Returns `TRUE` if the child widget is revealed.

See `gtk_expander_set_expanded()`.

#### Parameters

expander | a GtkExpander |

#### Returns

the current state of the expander.

Since: 2.4

### gtk_expander_set_spacing ()

    void
    gtk_expander_set_spacing (GtkExpander *expander,
                              gint spacing);

Sets the spacing field of `expander` , which is the number of pixels to place between expander and the child.

#### Parameters

expander | a GtkExpander |
spacing | distance between the expander and child in pixels. |

Since: 2.4

### gtk_expander_get_spacing ()

    gint
    gtk_expander_get_spacing (GtkExpander *expander);

Gets the value set by `gtk_expander_set_spacing()`.

#### Parameters

expander | a GtkExpander |

#### Returns

spacing between the expander and child.

Since: 2.4

### gtk_expander_set_label ()

    void
    gtk_expander_set_label (GtkExpander *expander,
                            const gchar *label);

Sets the text of the label of the expander to `label` .

This will also clear any previously set labels.

#### Parameters

expander | a GtkExpander |
label | a string. | [allow-none]

Since: 2.4

### gtk_expander_get_label ()

    const gchar *
    gtk_expander_get_label (GtkExpander *expander);

Fetches the text from a label widget including any embedded underlines indicating mnemonics and Pango markup, as set by `gtk_expander_set_label()`. If the label text has not been set the return value will be `NULL`. This will be the case if you create an empty button with `gtk_button_new()` to use as a container.

Note that this function behaved differently in versions prior to 2.14 and used to return the label text stripped of embedded underlines indicating mnemonics and Pango markup. This problem can be avoided by fetching the label text directly from the label widget.

#### Parameters

expander | a GtkExpander |

#### Returns

The text of the label widget. This string is owned by the widget and must not be modified or freed.

Since: 2.4

### gtk_expander_set_use_underline ()

    void
    gtk_expander_set_use_underline (GtkExpander *expander,
                                    gboolean use_underline);

If true, an underline in the text of the expander label indicates the next character should be used for the mnemonic accelerator key.

#### Parameters

expander | a GtkExpander |
use_underline | `TRUE` if underlines in the text indicate mnemonics |

Since: 2.4

### gtk_expander_get_use_underline ()

    gboolean
    gtk_expander_get_use_underline (GtkExpander *expander);

Returns whether an embedded underline in the expander label indicates a mnemonic. See `gtk_expander_set_use_underline()`.

#### Parameters

expander | a GtkExpander |

#### Returns

`TRUE` if an embedded underline in the expander label indicates the mnemonic accelerator keys.

Since: 2.4

### gtk_expander_set_use_markup ()

    void
    gtk_expander_set_use_markup (GtkExpander *expander,
                                 gboolean use_markup);

Sets whether the text of the label contains markup in Pango's text markup language. See `gtk_label_set_markup()`.

#### Parameters

expander | a GtkExpander |
use_markup | `TRUE` if the label's text should be parsed for markup |

Since: 2.4

### gtk_expander_get_use_markup ()

    gboolean
    gtk_expander_get_use_markup (GtkExpander *expander);

Returns whether the label's text is interpreted as marked up with the Pango text markup language. See `gtk_expander_set_use_markup()`.

#### Parameters

expander | a GtkExpander |

#### Returns

`TRUE` if the label's text will be parsed for markup

Since: 2.4

### gtk_expander_set_label_widget ()

    void
    gtk_expander_set_label_widget (GtkExpander *expander,
                                   GtkWidget *label_widget);

Set the label widget for the expander. This is the widget that will appear embedded alongside the expander arrow.

#### Parameters

expander | a GtkExpander |
label_widget | the new label widget. | [allow-none]

Since: 2.4

### gtk_expander_get_label_widget ()

    GtkWidget *
    gtk_expander_get_label_widget (GtkExpander *expander);

Retrieves the label widget for the frame. See `gtk_expander_set_label_widget()`.

#### Parameters

expander | a GtkExpander |

#### Returns

the label widget, or `NULL` if there is none.

[transfer none]

Since: 2.4

### gtk_expander_set_label_fill ()

    void
    gtk_expander_set_label_fill (GtkExpander *expander,
                                 gboolean label_fill);

Sets whether the label widget should fill all available horizontal space allocated to `expander` .

#### Parameters

expander | a GtkExpander |
label_fill | `TRUE` if the label should should fill all available horizontal space |

Since: 2.22

### gtk_expander_get_label_fill ()

    gboolean
    gtk_expander_get_label_fill (GtkExpander *expander);

Returns whether the label widget will fill all available horizontal space allocated to `expander` .

#### Parameters

expander | a GtkExpander |

#### Returns

`TRUE` if the label widget will fill all available horizontal space

Since: 2.22

## Types and Values

### struct GtkExpander

    struct GtkExpander;

## Property Details

### The `“expanded”` property

      “expanded”                 gboolean

Whether the expander has been opened to reveal the child widget.

Owner: GtkExpander

Flags: Read / Write / Construct

Default value: FALSE

### The `“label”` property

      “label”                    char *

Text of the expander's label.

Owner: GtkExpander

Flags: Read / Write / Construct

Default value: NULL

### The `“label-fill”` property

      “label-fill”               gboolean

Whether the label widget should fill all available horizontal space.

Owner: GtkExpander

Flags: Read / Write / Construct

Default value: FALSE

### The `“label-widget”` property

      “label-widget”             GtkWidget *

A widget to display in place of the usual expander label.

Owner: GtkExpander

Flags: Read / Write

### The `“spacing”` property

      “spacing”                  int

Space to put between the label and the child.

Owner: GtkExpander

Flags: Read / Write

Allowed values: >= 0

Default value: 0

### The `“use-markup”` property

      “use-markup”               gboolean

The text of the label includes XML markup. See pango_parse_markup().

Owner: GtkExpander

Flags: Read / Write / Construct

Default value: FALSE

### The `“use-underline”` property

      “use-underline”            gboolean

If set, an underline in the text indicates the next character should be used for the mnemonic accelerator key.

Owner: GtkExpander

Flags: Read / Write / Construct

Default value: FALSE

## Style Property Details

### The `“expander-size”` style property

      “expander-size”            int

Size of the expander arrow.

Owner: GtkExpander

Flags: Read

Allowed values: >= 0

Default value: 10

### The `“expander-spacing”` style property

      “expander-spacing”         int

Spacing around expander arrow.

Owner: GtkExpander

Flags: Read

Allowed values: >= 0

Default value: 2

## Signal Details

### The `“activate”` signal

    void
    user_function (GtkExpander *expander,
                   gpointer     user_data)

Flags: Action